Index: src/builder.cpp
===================================================================
--- src/builder.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/builder.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -1558,65 +1814,173 @@
                   }
               }
-              if (mol == NULL) {
+              if ((mol == NULL) && (!molecules->ListOfMolecules.empty())) {
                 mol = *(molecules->ListOfMolecules.begin());
-                mol->ActiveFlag = true;
+                if (mol != NULL)
+                  mol->ActiveFlag = true;
               }
               break;
             case 'C':
-              if (ExitFlag == 0) ExitFlag = 1;
-              if ((argptr+2 >= argc) || (!IsValidNumber(argv[argptr])) || (argv[argptr][0] == '-') || (argv[argptr+1][0] == '-') || (argv[argptr+2][0] == '-')) {
-                ExitFlag = 255;
-                eLog() << Verbose(0) << "Not enough or invalid arguments given for pair correlation analysis: -C <Z> <output> <bin output>" << endl;
-                performCriticalExit();
-              } else {
-                ofstream output(argv[argptr+1]);
-                ofstream binoutput(argv[argptr+2]);
-                const double radius = 5.;
-
-                // get the boundary
-                class molecule *Boundary = NULL;
-                class Tesselation *TesselStruct = NULL;
-                const LinkedCell *LCList = NULL;
-                // find biggest molecule
-                int counter  = 0;
-                for (MoleculeList::iterator BigFinder = molecules->ListOfMolecules.begin(); BigFinder != molecules->ListOfMolecules.end(); BigFinder++) {
-                  if ((Boundary == NULL) || (Boundary->AtomCount < (*BigFinder)->AtomCount)) {
-                    Boundary = *BigFinder;
+              {
+                int ranges[3] = {1, 1, 1};
+                bool periodic = (argv[argptr-1][2] =='p');
+                if (ExitFlag == 0) ExitFlag = 1;
+                if ((argptr >= argc)) {
+                  ExitFlag = 255;
+                  DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments given for pair correlation analysis: -C[p] <type: E/P/S> [more params] <output> <bin output> <BinStart> <BinEnd>" << endl);
+                  performCriticalExit();
+                } else {
+                  switch(argv[argptr][0]) {
+                    case 'E':
+                      {
+                        if ((argptr+6 >= argc) || (!IsValidNumber(argv[argptr+1])) || (!IsValidNumber(argv[argptr+5])) || (!IsValidNumber(argv[argptr+6])) || (!IsValidNumber(argv[argptr+2])) || (argv[argptr+1][0] == '-') || (argv[argptr+2][0] == '-') || (argv[argptr+3][0] == '-') || (argv[argptr+4][0] == '-')) {
+                          ExitFlag = 255;
+                          DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments given for pair correlation analysis: -C E <Z1> <Z2> <output> <bin output>" << endl);
+                          performCriticalExit();
+                        } else {
+                          ofstream output(argv[argptr+3]);
+                          ofstream binoutput(argv[argptr+4]);
+                          const double BinStart = atof(argv[argptr+5]);
+                          const double BinEnd = atof(argv[argptr+6]);
+
+                          const element *elemental = periode->FindElement((const int) atoi(argv[argptr+1]));
+                          const element *elemental2 = periode->FindElement((const int) atoi(argv[argptr+2]));
+                          PairCorrelationMap *correlationmap = NULL;
+                          if (periodic)
+                            correlationmap = PeriodicPairCorrelation(molecules, elemental, elemental2, ranges);
+                          else
+                            correlationmap = PairCorrelation(molecules, elemental, elemental2);
+                          //OutputCorrelationToSurface(&output, correlationmap);
+                          BinPairMap *binmap = BinData( correlationmap, 0.5, BinStart, BinEnd );
+                          OutputCorrelation ( &binoutput, binmap );
+                          output.close();
+                          binoutput.close();
+                          delete(binmap);
+                          delete(correlationmap);
+                          argptr+=7;
+                        }
+                      }
+                      break;
+
+                    case 'P':
+                      {
+                        if ((argptr+8 >= argc) || (!IsValidNumber(argv[argptr+1])) ||  (!IsValidNumber(argv[argptr+2])) || (!IsValidNumber(argv[argptr+3])) || (!IsValidNumber(argv[argptr+4])) || (!IsValidNumber(argv[argptr+7])) || (!IsValidNumber(argv[argptr+8])) || (argv[argptr+1][0] == '-') || (argv[argptr+2][0] == '-') || (argv[argptr+3][0] == '-') || (argv[argptr+4][0] == '-') || (argv[argptr+5][0] == '-') || (argv[argptr+6][0] == '-')) {
+                          ExitFlag = 255;
+                          DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments given for pair correlation analysis: -C P <Z1> <x> <y> <z> <output> <bin output>" << endl);
+                          performCriticalExit();
+                        } else {
+                          ofstream output(argv[argptr+5]);
+                          ofstream binoutput(argv[argptr+6]);
+                          const double BinStart = atof(argv[argptr+7]);
+                          const double BinEnd = atof(argv[argptr+8]);
+
+                          const element *elemental = periode->FindElement((const int) atoi(argv[argptr+1]));
+                          Vector *Point = new Vector((const double) atof(argv[argptr+1]),(const double) atof(argv[argptr+2]),(const double) atof(argv[argptr+3]));
+                          CorrelationToPointMap *correlationmap = NULL;
+                          if (periodic)
+                            correlationmap  = PeriodicCorrelationToPoint(molecules, elemental, Point, ranges);
+                          else
+                            correlationmap = CorrelationToPoint(molecules, elemental, Point);
+                          //OutputCorrelationToSurface(&output, correlationmap);
+                          BinPairMap *binmap = BinData( correlationmap, 0.5, BinStart, BinEnd );
+                          OutputCorrelation ( &binoutput, binmap );
+                          output.close();
+                          binoutput.close();
+                          delete(Point);
+                          delete(binmap);
+                          delete(correlationmap);
+                          argptr+=9;
+                        }
+                      }
+                      break;
+
+                    case 'S':
+                      {
+                        if ((argptr+6 >= argc) || (!IsValidNumber(argv[argptr+1])) || (!IsValidNumber(argv[argptr+4])) || (!IsValidNumber(argv[argptr+5])) || (!IsValidNumber(argv[argptr+6])) || (argv[argptr+1][0] == '-') || (argv[argptr+2][0] == '-') || (argv[argptr+3][0] == '-')) {
+                          ExitFlag = 255;
+                          DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments given for pair correlation analysis: -C S <Z> <output> <bin output> <BinWidth> <BinStart> <BinEnd>" << endl);
+                          performCriticalExit();
+                        } else {
+                          ofstream output(argv[argptr+2]);
+                          ofstream binoutput(argv[argptr+3]);
+                          const double radius = 4.;
+                          const double BinWidth = atof(argv[argptr+4]);
+                          const double BinStart = atof(argv[argptr+5]);
+                          const double BinEnd = atof(argv[argptr+6]);
+                          double LCWidth = 20.;
+                          if (BinEnd > 0) {
+                            if (BinEnd > 2.*radius)
+                                LCWidth = BinEnd;
+                            else
+                              LCWidth = 2.*radius;
+                          }
+
+                          // get the boundary
+                          class molecule *Boundary = NULL;
+                          class Tesselation *TesselStruct = NULL;
+                          const LinkedCell *LCList = NULL;
+                          // find biggest molecule
+                          int counter  = 0;
+                          for (MoleculeList::iterator BigFinder = molecules->ListOfMolecules.begin(); BigFinder != molecules->ListOfMolecules.end(); BigFinder++) {
+                            if ((Boundary == NULL) || (Boundary->AtomCount < (*BigFinder)->AtomCount)) {
+                              Boundary = *BigFinder;
+                            }
+                            counter++;
+                          }
+                          bool *Actives = Malloc<bool>(counter, "ParseCommandLineOptions() - case C -- *Actives");
+                          counter = 0;
+                          for (MoleculeList::iterator BigFinder = molecules->ListOfMolecules.begin(); BigFinder != molecules->ListOfMolecules.end(); BigFinder++) {
+                            Actives[counter++] = (*BigFinder)->ActiveFlag;
+                            (*BigFinder)->ActiveFlag = (*BigFinder == Boundary) ? false : true;
+                          }
+                          LCList = new LinkedCell(Boundary, LCWidth);
+                          const element *elemental = periode->FindElement((const int) atoi(argv[argptr+1]));
+                          FindNonConvexBorder(Boundary, TesselStruct, LCList, radius, NULL);
+                          CorrelationToSurfaceMap *surfacemap = NULL;
+                          if (periodic)
+                            surfacemap = PeriodicCorrelationToSurface( molecules, elemental, TesselStruct, LCList, ranges);
+                          else
+                            surfacemap = CorrelationToSurface( molecules, elemental, TesselStruct, LCList);
+                          OutputCorrelationToSurface(&output, surfacemap);
+                          // check whether radius was appropriate
+                          {
+                            double start; double end;
+                            GetMinMax( surfacemap, start, end);
+                            if (LCWidth < end)
+                              DoeLog(1) && (eLog()<< Verbose(1) << "Linked Cell width is smaller than the found range of values! Bins can only be correct up to: " << radius << "." << endl);
+                          }
+                          BinPairMap *binmap = BinData( surfacemap, BinWidth, BinStart, BinEnd );
+                          OutputCorrelation ( &binoutput, binmap );
+                          output.close();
+                          binoutput.close();
+                          for (MoleculeList::iterator BigFinder = molecules->ListOfMolecules.begin(); BigFinder != molecules->ListOfMolecules.end(); BigFinder++)
+                            (*BigFinder)->ActiveFlag = Actives[counter++];
+                          Free(&Actives);
+                          delete(LCList);
+                          delete(TesselStruct);
+                          delete(binmap);
+                          delete(surfacemap);
+                          argptr+=7;
+                        }
+                      }
+                      break;
+
+                    default:
+                      ExitFlag = 255;
+                      DoeLog(0) && (eLog()<< Verbose(0) << "Invalid type given for pair correlation analysis: -C <type: E/P/S> [more params] <output> <bin output>" << endl);
+                      performCriticalExit();
+                      break;
                   }
-                  counter++;
                 }
-                bool *Actives = Malloc<bool>(counter, "ParseCommandLineOptions() - case C -- *Actives");
-                counter = 0;
-                for (MoleculeList::iterator BigFinder = molecules->ListOfMolecules.begin(); BigFinder != molecules->ListOfMolecules.end(); BigFinder++) {
-                  Actives[counter++] = (*BigFinder)->ActiveFlag;
-                  (*BigFinder)->ActiveFlag = (*BigFinder == Boundary) ? false : true;
-                }
-                LCList = new LinkedCell(Boundary, 2.*radius);
-                element *elemental = periode->FindElement((const int) atoi(argv[argptr]));
-                FindNonConvexBorder(Boundary, TesselStruct, LCList, radius, NULL);
-                int ranges[NDIM] = {1,1,1};
-                CorrelationToSurfaceMap *surfacemap = PeriodicCorrelationToSurface( molecules, elemental, TesselStruct, LCList, ranges );
-                OutputCorrelationToSurface(&output, surfacemap);
-                BinPairMap *binmap = BinData( surfacemap, 0.5, 0., 20. );
-                OutputCorrelation ( &binoutput, binmap );
-                output.close();
-                binoutput.close();
-                for (MoleculeList::iterator BigFinder = molecules->ListOfMolecules.begin(); BigFinder != molecules->ListOfMolecules.end(); BigFinder++)
-                  (*BigFinder)->ActiveFlag = Actives[counter++];
-                Free(&Actives);
-                delete(LCList);
-                delete(TesselStruct);
-                argptr+=3;
-              }
-              break;
+                break;
+              }
             case 'E':
               if (ExitFlag == 0) ExitFlag = 1;
               if ((argptr+1 >= argc) || (!IsValidNumber(argv[argptr])) || (argv[argptr+1][0] == '-')) {
                 ExitFlag = 255;
-                eLog() << Verbose(0) << "Not enough or invalid arguments given for changing element: -E <atom nr.> <element>" << endl;
+                DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments given for changing element: -E <atom nr.> <element>" << endl);
                 performCriticalExit();
               } else {
                 SaveFlag = true;
-                Log() << Verbose(1) << "Changing atom " << argv[argptr] << " to element " << argv[argptr+1] << "." << endl;
+                DoLog(1) && (Log() << Verbose(1) << "Changing atom " << argv[argptr] << " to element " << argv[argptr+1] << "." << endl);
                 first = mol->FindAtom(atoi(argv[argptr]));
                 first->type = periode->FindElement(atoi(argv[argptr+1]));
@@ -1626,30 +1990,37 @@
             case 'F':
               if (ExitFlag == 0) ExitFlag = 1;
-              if (argptr+6 >=argc) {
+              MaxDistance = -1;
+              if (argv[argptr-1][2] == 'F') { // option is -FF?
+                // fetch first argument as max distance to surface
+                MaxDistance = atof(argv[argptr++]);
+                DoLog(0) && (Log() << Verbose(0) << "Filling with maximum layer distance of " << MaxDistance << "." << endl);
+              }
+              if ((argptr+7 >=argc) || (argv[argptr][0] == '-') || (!IsValidNumber(argv[argptr+1])) || (!IsValidNumber(argv[argptr+2])) || (!IsValidNumber(argv[argptr+3])) || (!IsValidNumber(argv[argptr+4])) || (!IsValidNumber(argv[argptr+5])) || (!IsValidNumber(argv[argptr+6])) || (!IsValidNumber(argv[argptr+7]))) {
                 ExitFlag = 255;
-                eLog() << Verbose(0) << "Not enough or invalid arguments given for filling box with water: -F <dist_x> <dist_y> <dist_z> <boundary> <randatom> <randmol> <DoRotate>" << endl;
+                DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments given for filling box with water: -F <xyz of filler> <dist_x> <dist_y> <dist_z> <boundary> <randatom> <randmol> <DoRotate>" << endl);
                 performCriticalExit();
               } else {
                 SaveFlag = true;
-                Log() << Verbose(1) << "Filling Box with water molecules." << endl;
+                DoLog(1) && (Log() << Verbose(1) << "Filling Box with water molecules." << endl);
                 // construct water molecule
-                molecule *filler = new molecule(periode);
+                molecule *filler = World::getInstance().createMolecule();
+                if (!filler->AddXYZFile(argv[argptr])) {
+                  DoeLog(0) && (eLog()<< Verbose(0) << "Could not parse filler molecule from " << argv[argptr] << "." << endl);
+                }
+                filler->SetNameFromFilename(argv[argptr]);
+                configuration.BG->ConstructBondGraph(filler);
                 molecule *Filling = NULL;
                 atom *second = NULL, *third = NULL;
-//                first = new atom();
-//                first->type = periode->FindElement(5);
-//                first->x.Zero();
-//                filler->AddAtom(first);
-                first = new atom();
+                first = World::getInstance().createAtom();
                 first->type = periode->FindElement(1);
-                first->x.Init(0.441, -0.143, 0.);
+                first->x = Vector(0.441, -0.143, 0.);
                 filler->AddAtom(first);
-                second = new atom();
+                second = World::getInstance().createAtom();
                 second->type = periode->FindElement(1);
-                second->x.Init(-0.464, 1.137, 0.0);
+                second->x = Vector(-0.464, 1.137, 0.0);
                 filler->AddAtom(second);
-                third = new atom();
+                third = World::getInstance().createAtom();
                 third->type = periode->FindElement(8);
-                third->x.Init(-0.464, 0.177, 0.);
+                third->x = Vector(-0.464, 0.177, 0.);
                 filler->AddAtom(third);
                 filler->AddBond(first, third, 1);
@@ -1658,11 +2029,11 @@
                 double distance[NDIM];
                 for (int i=0;i<NDIM;i++)
-                  distance[i] = atof(argv[argptr+i]);
-                Filling = FillBoxWithMolecule(molecules, filler, configuration, distance, atof(argv[argptr+3]), atof(argv[argptr+4]), atof(argv[argptr+5]), atoi(argv[argptr+6]));
+                  distance[i] = atof(argv[argptr+i+1]);
+                Filling = FillBoxWithMolecule(molecules, filler, configuration, MaxDistance, distance, atof(argv[argptr+4]), atof(argv[argptr+5]), atof(argv[argptr+6]), atoi(argv[argptr+7]));
                 if (Filling != NULL) {
                   Filling->ActiveFlag = false;
                   molecules->insert(Filling);
                 }
-                delete(filler);
+                World::getInstance().destroyMolecule(filler);
                 argptr+=6;
               }
@@ -1672,8 +2043,8 @@
               if ((argptr >= argc) || (argv[argptr][0] == '-')) {
                 ExitFlag =255;
-                eLog() << Verbose(0) << "Missing source file for bonds in molecule: -A <bond sourcefile>" << endl;
+                DoeLog(0) && (eLog()<< Verbose(0) << "Missing source file for bonds in molecule: -A <bond sourcefile>" << endl);
                 performCriticalExit();
               } else {
-                Log() << Verbose(0) << "Parsing bonds from " << argv[argptr] << "." << endl;
+                DoLog(0) && (Log() << Verbose(0) << "Parsing bonds from " << argv[argptr] << "." << endl);
                 ifstream *input = new ifstream(argv[argptr]);
                 mol->CreateAdjacencyListFromDbondFile(input);
@@ -1687,10 +2058,10 @@
               if ((argptr >= argc) || (argv[argptr][0] == '-')) {
                 ExitFlag =255;
-                eLog() << Verbose(0) << "Missing path of adjacency file: -j <path>" << endl;
+                DoeLog(0) && (eLog()<< Verbose(0) << "Missing path of adjacency file: -j <path>" << endl);
                 performCriticalExit();
               } else {
-                Log() << Verbose(0) << "Storing adjacency to path " << argv[argptr] << "." << endl;
+                DoLog(0) && (Log() << Verbose(0) << "Storing adjacency to path " << argv[argptr] << "." << endl);
                 configuration.BG->ConstructBondGraph(mol);
-                mol->StoreAdjacencyToFile(argv[argptr]);
+                mol->StoreAdjacencyToFile(NULL, argv[argptr]);
                 argptr+=1;
               }
@@ -1701,10 +2072,10 @@
               if ((argptr >= argc) || (argv[argptr][0] == '-')) {
                 ExitFlag =255;
-                eLog() << Verbose(0) << "Missing path of bonds file: -j <path>" << endl;
+                DoeLog(0) && (eLog()<< Verbose(0) << "Missing path of bonds file: -j <path>" << endl);
                 performCriticalExit();
               } else {
-                Log() << Verbose(0) << "Storing bonds to path " << argv[argptr] << "." << endl;
+                DoLog(0) && (Log() << Verbose(0) << "Storing bonds to path " << argv[argptr] << "." << endl);
                 configuration.BG->ConstructBondGraph(mol);
-                mol->StoreBondsToFile(argv[argptr]);
+                mol->StoreBondsToFile(NULL, argv[argptr]);
                 argptr+=1;
               }
@@ -1715,5 +2086,5 @@
               if ((argptr+1 >= argc) || (argv[argptr+1][0] == '-')){
                 ExitFlag = 255;
-                eLog() << Verbose(0) << "Not enough or invalid arguments given for non-convex envelope: -o <radius> <tecplot output file>" << endl;
+                DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments given for non-convex envelope: -o <radius> <tecplot output file>" << endl);
                 performCriticalExit();
               } else {
@@ -1723,6 +2094,6 @@
                 //string filename(argv[argptr+1]);
                 //filename.append(".csv");
-                Log() << Verbose(0) << "Evaluating non-convex envelope of biggest molecule.";
-                Log() << Verbose(1) << "Using rolling ball of radius " << atof(argv[argptr]) << " and storing tecplot data in " << argv[argptr+1] << "." << endl;
+                DoLog(0) && (Log() << Verbose(0) << "Evaluating non-convex envelope of biggest molecule.");
+                DoLog(1) && (Log() << Verbose(1) << "Using rolling ball of radius " << atof(argv[argptr]) << " and storing tecplot data in " << argv[argptr+1] << "." << endl);
                 // find biggest molecule
                 int counter  = 0;
@@ -1734,5 +2105,5 @@
                   counter++;
                 }
-                Log() << Verbose(1) << "Biggest molecule has " << Boundary->AtomCount << " atoms." << endl;
+                DoLog(1) && (Log() << Verbose(1) << "Biggest molecule has " << Boundary->AtomCount << " atoms." << endl);
                 start = clock();
                 LCList = new LinkedCell(Boundary, atof(argv[argptr])*2.);
@@ -1741,5 +2112,5 @@
                 //FindDistributionOfEllipsoids(T, &LCList, N, number, filename.c_str());
                 end = clock();
-                Log() << Verbose(0) << "Clocks for this operation: " << (end-start) << ", time: " << ((double)(end-start)/CLOCKS_PER_SEC) << "s." << endl;
+                DoLog(0) && (Log() << Verbose(0) << "Clocks for this operation: " << (end-start) << ", time: " << ((double)(end-start)/CLOCKS_PER_SEC) << "s." << endl);
                 delete(LCList);
                 delete(T);
@@ -1751,13 +2122,13 @@
               if ((argptr >= argc) || (argv[argptr][0] == '-')) {
                 ExitFlag = 255;
-                eLog() << Verbose(0) << "Not enough or invalid arguments given for storing tempature: -S <temperature file>" << endl;
+                DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments given for storing tempature: -S <temperature file>" << endl);
                 performCriticalExit();
               } else {
-                Log() << Verbose(1) << "Storing temperatures in " << argv[argptr] << "." << endl;
+                DoLog(1) && (Log() << Verbose(1) << "Storing temperatures in " << argv[argptr] << "." << endl);
                 ofstream *output = new ofstream(argv[argptr], ios::trunc);
                 if (!mol->OutputTemperatureFromTrajectories(output, 0, mol->MDSteps))
-                  Log() << Verbose(2) << "File could not be written." << endl;
+                  DoLog(2) && (Log() << Verbose(2) << "File could not be written." << endl);
                 else
-                  Log() << Verbose(2) << "File stored." << endl;
+                  DoLog(2) && (Log() << Verbose(2) << "File stored." << endl);
                 output->close();
                 delete(output);
@@ -1769,15 +2140,15 @@
               if ((argptr >= argc) || (argv[argptr][0] == '-')) {
                 ExitFlag = 255;
-                eLog() << Verbose(0) << "Not enough or invalid arguments given for storing tempature: -L <step0> <step1> <prefix> <identity mapping?>" << endl;
+                DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments given for storing tempature: -L <step0> <step1> <prefix> <identity mapping?>" << endl);
                 performCriticalExit();
               } else {
                 SaveFlag = true;
-                Log() << Verbose(1) << "Linear interpolation between configuration " << argv[argptr] << " and " << argv[argptr+1] << "." << endl;
+                DoLog(1) && (Log() << Verbose(1) << "Linear interpolation between configuration " << argv[argptr] << " and " << argv[argptr+1] << "." << endl);
                 if (atoi(argv[argptr+3]) == 1)
-                  Log() << Verbose(1) << "Using Identity for the permutation map." << endl;
+                  DoLog(1) && (Log() << Verbose(1) << "Using Identity for the permutation map." << endl);
                 if (!mol->LinearInterpolationBetweenConfiguration(atoi(argv[argptr]), atoi(argv[argptr+1]), argv[argptr+2], configuration, atoi(argv[argptr+3])) == 1 ? true : false)
-                  Log() << Verbose(2) << "Could not store " << argv[argptr+2] << " files." << endl;
+                  DoLog(2) && (Log() << Verbose(2) << "Could not store " << argv[argptr+2] << " files." << endl);
                 else
-                  Log() << Verbose(2) << "Steps created and " << argv[argptr+2] << " files stored." << endl;
+                  DoLog(2) && (Log() << Verbose(2) << "Steps created and " << argv[argptr+2] << " files stored." << endl);
                 argptr+=4;
               }
@@ -1787,13 +2158,13 @@
               if ((argptr >= argc) || (argv[argptr][0] == '-')) {
                 ExitFlag = 255;
-                eLog() << Verbose(0) << "Not enough or invalid arguments given for parsing and integrating forces: -P <forces file>" << endl;
+                DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments given for parsing and integrating forces: -P <forces file>" << endl);
                 performCriticalExit();
               } else {
                 SaveFlag = true;
-                Log() << Verbose(1) << "Parsing forces file and Verlet integrating." << endl;
+                DoLog(1) && (Log() << Verbose(1) << "Parsing forces file and Verlet integrating." << endl);
                 if (!mol->VerletForceIntegration(argv[argptr], configuration))
-                  Log() << Verbose(2) << "File not found." << endl;
+                  DoLog(2) && (Log() << Verbose(2) << "File not found." << endl);
                 else
-                  Log() << Verbose(2) << "File found and parsed." << endl;
+                  DoLog(2) && (Log() << Verbose(2) << "File found and parsed." << endl);
                 argptr+=1;
               }
@@ -1803,9 +2174,9 @@
               if ((argptr+1 >= argc) || (argv[argptr][0] == '-') || (!IsValidNumber(argv[argptr])) || (!IsValidNumber(argv[argptr+1])))  {
                 ExitFlag = 255;
-                eLog() << Verbose(0) << "Not enough or invalid arguments given for removing atoms: -R <id> <distance>" << endl;
+                DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments given for removing atoms: -R <id> <distance>" << endl);
                 performCriticalExit();
               } else {
                 SaveFlag = true;
-                Log() << Verbose(1) << "Removing atoms around " << argv[argptr] << " with radius " << argv[argptr+1] << "." << endl;
+                DoLog(1) && (Log() << Verbose(1) << "Removing atoms around " << argv[argptr] << " with radius " << argv[argptr+1] << "." << endl);
                 double tmp1 = atof(argv[argptr+1]);
                 atom *third = mol->FindAtom(atoi(argv[argptr]));
@@ -1816,9 +2187,9 @@
                     first = second;
                     second = first->next;
-                    if (first->x.DistanceSquared((const Vector *)&third->x) > tmp1*tmp1) // distance to first above radius ...
+                    if (first->x.DistanceSquared(third->x) > tmp1*tmp1) // distance to first above radius ...
                       mol->RemoveAtom(first);
                   }
                 } else {
-                  eLog() << Verbose(1) << "Removal failed due to missing atoms on molecule or wrong id." << endl;
+                  DoeLog(1) && (eLog()<< Verbose(1) << "Removal failed due to missing atoms on molecule or wrong id." << endl);
                 }
                 argptr+=2;
@@ -1829,12 +2200,12 @@
               if ((argptr+2 >= argc) || (!IsValidNumber(argv[argptr])) || (!IsValidNumber(argv[argptr+1])) || (!IsValidNumber(argv[argptr+2])) ) {
                 ExitFlag = 255;
-                eLog() << Verbose(0) << "Not enough or invalid arguments given for translation: -t <x> <y> <z>" << endl;
+                DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments given for translation: -t <x> <y> <z>" << endl);
                 performCriticalExit();
               } else {
                 if (ExitFlag == 0) ExitFlag = 1;
                 SaveFlag = true;
-                Log() << Verbose(1) << "Translating all ions by given vector." << endl;
+                DoLog(1) && (Log() << Verbose(1) << "Translating all ions by given vector." << endl);
                 for (int i=NDIM;i--;)
-                  x.x[i] = atof(argv[argptr+i]);
+                  x[i] = atof(argv[argptr+i]);
                 mol->Translate((const Vector *)&x);
                 argptr+=3;
@@ -1845,12 +2216,12 @@
               if ((argptr+2 >= argc) || (!IsValidNumber(argv[argptr])) || (!IsValidNumber(argv[argptr+1])) || (!IsValidNumber(argv[argptr+2])) ) {
                 ExitFlag = 255;
-                eLog() << Verbose(0) << "Not enough or invalid arguments given for periodic translation: -T <x> <y> <z>" << endl;
+                DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments given for periodic translation: -T <x> <y> <z>" << endl);
                 performCriticalExit();
               } else {
                 if (ExitFlag == 0) ExitFlag = 1;
                 SaveFlag = true;
-                Log() << Verbose(1) << "Translating all ions periodically by given vector." << endl;
+                DoLog(1) && (Log() << Verbose(1) << "Translating all ions periodically by given vector." << endl);
                 for (int i=NDIM;i--;)
-                  x.x[i] = atof(argv[argptr+i]);
+                  x[i] = atof(argv[argptr+i]);
                 mol->TranslatePeriodically((const Vector *)&x);
                 argptr+=3;
